#include <cstdlib>
#include <iostream>

using namespace std;

int main()
{
    char srcfile[256];
    char dstfile[256];
    unsigned long int begin_off;  //offset in source file to start reading
    unsigned long int end_off;    //last offset in source file to read
    unsigned long int copy_off;   //offset in destination file to read
    unsigned long int copysize;
    unsigned char readbyte;
    bool newfile = 0; //create a new file or overwrite existing? 0=overwrite 1=new
    cout<<"File with source data:";
    cin>>srcfile;
    cout<<"First byte in file to copy:";
    cin>>hex>>begin_off;
    cout<<"Last byte in the file to oopy:";
    cin>>hex>>end_off;
    cout<<"File to insert data to:";
    cin>>dstfile;
    cout<<"Offset to insert data at:";
    cin>>hex>>copy_off;
    FILE *src = fopen(srcfile,"rb");
    FILE *dst;
    copy_off = copy_off + (end_off-begin_off);
    copysize = end_off-begin_off + 1;
    if(src==NULL)
    {
       cout<<"Cannot read input file.\n";
       system("PAUSE");
       return EXIT_FAILURE;
    }
    if (strcmp(srcfile,dstfile)==0)    //same file.
    {
        dst = fopen(dstfile,"rb+");
    }
    else
    {
        if (fopen(dstfile,"r")!= NULL)  //file exists
        {
            cout<<"Overwrite? (0 = Write to existing file. Anything else to delete the old file.";
            cin>>newfile;
        }
        if (newfile==0)
        {
            dst = fopen(dstfile,"rb+");
        }
        else
        {
            dst = fopen(dstfile,"wb");
        }
    }
    if(dst==NULL)
    {
        cout<<"Cannot find output file.\n";
        cout<<"It will be created.\n";
        dst = fopen(dstfile,"wb");
    }
    if(end_off<begin_off)
    {
        cout<<"Ending offset is less than the beginning offset.\n";
        system("PAUSE");
        return EXIT_FAILURE;
    }
    while(copysize!=0)
    {
        //write the file backwards, to avoid overlap of new and old data
        fseek(src,end_off,SEEK_SET);
        readbyte=fgetc(src);
        fseek(dst,copy_off,SEEK_SET);
        fputc(readbyte,dst);
        end_off--; copysize--; copy_off--;
    }
    cout<<"Copy done.\n";
    system("PAUSE");
    return EXIT_SUCCESS;
}
